/*	COLOR_TO_Gray . C
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

This software is copyright (C) by the Lawrence Berkeley Laboratory.
Permission is granted to reproduce this software for non-commercial
purposes provided that this notice is left intact.

It is acknowledged that the U.S. Government has rights to this software
under Contract DE-AC03-765F00098 between the U.S.  Department of Energy
and the University of California.

This software is provided as a professional and academic contribution
for joint exchange. Thus, it is experimental, and is provided ``as is'',
with no warranties of any kind whatsoever, no support, no promise of
updates, or printed documentation. By using this software, you
acknowledge that the Lawrence Berkeley Laboratory and Regents of the
University of California shall have no liability with respect to the
infringement of other copyrights by any part of this software.

For further information about this notice, contact William Johnston,
Bld. 50B, Rm. 2239, Lawrence Berkeley Laboratory, Berkeley, CA, 94720.
(wejohnston@lbl.gov)

For further information about this software, contact:
	Jin Guojun
	Bld. 50B, Rm. 2275, Lawrence Berkeley Laboratory, Berkeley, CA, 94720.
	g_jin@lbl.gov

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% AUTHOR:	Jin Guojun - LBL	8/1/91
*/

#include "header.def"

#define	CNVT(x)		((x)*256 / 100)

#ifndef	cmap_t
#define	cmap_t	byte
#endif

/* weighting % -> fraction of full color */
int	RED_to_GRAY = CNVT(29),		/* 28% */
	GREEN_to_GRAY = CNVT(59),	/* 59% */
	BLUE_to_GRAY = CNVT(12);	/* 11% */
#define	work_v	register int	\
		red = RED_to_GRAY, green = GREEN_to_GRAY, blue = BLUE_to_GRAY


ilc_to_gray(out, rgb, n, alpha, map, Regular_T)
register byte	*out, *rgb;
register unsigned int	n;
bool	alpha;
cmap_t*	map[3];
{
work_v, v;

if(Regular_T)
    if (map)
	while (n--) {	/* may not work with 4 bit color images */
		if (alpha)	rgb++;	/* skip alpha channel */
		v = red*(map[0][*rgb++]);
		v += green*(map[1][*rgb++]);
		v += blue*(map[2][*rgb++]);
		*out++ = v>>8;
	}
    else while (n--) {
		if (alpha)	rgb++;
		v = red*(*rgb++);
		v += green*(*rgb++);
		v += blue*(*rgb++);
		*out++ = v>>8;
	}
else if (map)
    while (n--) {
	if (alpha)	rgb++;		/* skip alpha channel */
	v = blue*(map[0][*rgb++]);	/* may not work with 4 bit color images */
	v += green*(map[1][*rgb++]);
	v += red*(map[2][*rgb++]);
	*out++ = v>>8;
}
else while (n--) {
	if (alpha)	rgb++;
	v = blue*(*rgb++);
	v += green*(*rgb++);
	v += red*(*rgb++);
	*out++ = v>>8;
}
}


ill_to_gray(out, r, g, b, w)
register byte	*out, *r, *g, *b;
register unsigned int	w;
{
work_v;

while (w--)
	*out++ = (red*(*r++) + green*(*g++) + blue*(*b++)) >> 8;
}


map8_gray(out, rgb, n, map)
register byte	*out, *rgb;
register unsigned int	n;
cmap_t*	map[3];
{
work_v, v;

while (n--)	{
	v = red*(map[0][*rgb]);	/* may not work with 4 bit color images */
	v += green*(map[1][*rgb]);
	v += blue*(map[2][*rgb++]);
	*out++ = v >> 8;
}
}

line_to_sep_color(out, rgb, w, h, ch)
register char	*out;
char	*rgb;
{
register int	c, hi;
register char	*r=rgb;
for (c=ch; c--; r=rgb += w)
	for (hi=h; hi--; out+=w, r += ch*w)
		memcpy(out, r, w);
}
