/*
*	message.c - messages
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

This software is copyright (C) by the Lawrence Berkeley Laboratory.
Permission is granted to reproduce this software for non-commercial
purposes provided that this notice is left intact.

It is acknowledged that the U.S. Government has rights to this software
under Contract DE-AC03-765F00098 between the U.S.  Department of Energy
and the University of California.

This software is provided as a professional and academic contribution
for joint exchange. Thus, it is experimental, and is provided ``as is'',
with no warranties of any kind whatsoever, no support, no promise of
updates, or printed documentation. By using this software, you
acknowledge that the Lawrence Berkeley Laboratory and Regents of the
University of California shall have no liability with respect to the
infringement of other copyrights by any part of this software.

For further information about this notice, contact William Johnston,
Bld. 50B, Rm. 2239, Lawrence Berkeley Laboratory, Berkeley, CA, 94720.
(wejohnston@lbl.gov)

For further information about this software, contact:
	Jin Guojun
	Bld. 50B, Rm. 2275, Lawrence Berkeley Laboratory, Berkeley, CA, 94720.
	g_jin@lbl.gov

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% AUTHOR:	Jin Guojun - LBL	10/1/90
*/

#include "header.def"

/* only init_header() uses this
char	*desc_massage(s)
char*	s;
{
int	i, beg=1, len=strlen(s);

for (i=0; i < len; i++)	{
    if (beg && *(s+i) == '.' && *(s+i+1) == '\n')	{
	i--;
	len -= 2;
	memcpy(s+i, s+i+2, len-i);
    }
    else	beg = (s[i]=='\n');
}
return(s);
}
*/

#if defined TC_Need
#	include <stdarg.h>

message(const char *vform, ...)
{
vfprintf(stderr, vform, ...);
return	fflush(stderr);
}

#else

#	include <varargs.h>

#ifndef	NO_V_LIST

#ifdef	MIPS
message(char* vform, ...)
#else
message(vform, va_alist)
va_list	va_alist;
#endif
{
va_list	ap;
va_start(ap);
vfprintf(stderr, (char*)vform, ap);
return	fflush(stderr);
}

#else

message(form, a0, a1, a2, a3, a4, a5, a6, ap)
char*	form;
va_list	ap;
{
return	fprintf(stderr, form, a0, a1, a2, a3, a4, a5, a6, ap);
}

#endif	V_LIST

#endif	TC_Need
